package com.rm.dnndash;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import com.rm.dnndash.data.ControlXml;
import com.rm.dnndash.data.ControlXmlList;
import com.rm.dnndash.data.DashParser;

import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;

/**
 * Created with IntelliJ IDEA.
 * User: ROB
 * Date: 7/10/12
 * Time: 2:24 PM
 * To change this template use File | Settings | File Templates.
 */
public class MenuActivity extends ListActivity {

    public static final String CLASSTAG = MenuActivity.class.getSimpleName();

    private SortedMap<String, Object> actions = new TreeMap<String, Object>();

    private ControlXmlList dashControls;

    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
        String key = (String) l.getItemAtPosition(position);
        Intent detailIntent = (Intent)actions.get(key);
        detailIntent.putExtra(Constants.CONTROL_NAME, key); // The sub element in the xml
        //detailIntent.putExtra(Constants.CONTROL_XML, getIntent().getStringExtra(Constants.XML_KEY));
        detailIntent.putExtra(Constants.CONTROL_XML, dashControls.findByName(key).xml);

        startActivity((Intent) detailIntent);
    }

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        this.setContentView(R.layout.dash_menu);

        Intent intent = getIntent();
        String xml = intent.getStringExtra(Constants.XML_KEY);
        Log.d(CLASSTAG, xml);

        prepareMenu(xml);

        String[] keys = actions.keySet().toArray(
                new String[actions.keySet().size()]);

        setListAdapter(new ArrayAdapter<String>(this,
                android.R.layout.simple_list_item_1, keys));
    }

    public void addMenuItem(String label, Class<?> cls){
        actions.put(label, new Intent(this, cls	));
    }

    void prepareMenu(String xml) {

        this.dashControls = DashParser.parseDashControls(xml);
        for(ControlXml controlXml : dashControls) {
            Log.d(CLASSTAG, "Adding menuItem: " + controlXml);
            addMenuItem(
                    controlXml.name,
                    SettingsActivity.class); // TODO custom Activity classes?
        }


    }
}
