package com.rm.dnndash;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;
import com.rm.dnndash.data.DashParser;
import com.rm.dnndash.data.Setting;

import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: ROB
 * Date: 7/10/12
 * Time: 8:39 PM
 * Settings detail view for a specific dashControl
 */
public class SettingsActivity extends Activity {

    private static final String CLASSTAG = SettingsActivity.class.getSimpleName();
    TextView uiXml;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        this.setContentView(R.layout.settings);
        this.uiXml = (TextView)findViewById(R.id.xml_view);
        TextView settingsLabel = (TextView)findViewById(R.id.settings_label);

        Log.d(CLASSTAG, "onCreate()");

        // Get extras
        Intent intent = getIntent();
        String controlName = intent.getStringExtra(Constants.CONTROL_NAME);
        Log.d(CLASSTAG, "controlName: " + controlName);
        String xml = intent.getStringExtra(Constants.CONTROL_XML);
        //String xml = intent.getStringExtra(Constants.XML_KEY); // all the xml

        // Set screen title
        settingsLabel.setText(controlName);

        if(xml != null) {
            Log.d(CLASSTAG, xml);
            StringBuilder sb = new StringBuilder();
            List<Setting> settings = DashParser.parseControlSettings(xml, controlName);
            for(Setting setting : settings) {
                Log.d(CLASSTAG, "Parsed setting key: " + setting.key);
                Log.d(CLASSTAG, "Parsed setting value: " + setting.value);
                sb.append(setting.key);
                sb.append(" : ");
                sb.append(setting.value);
                sb.append("\n");
            }

            this.uiXml.setText(sb.toString()); // TODO remove and replace with Adapter


        }
    }
}
